/*
 * generated by Xtext 2.29.0
 */
package org.eclipse.papyrus.robotics.xtext.compdef.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.papyrus.robotics.xtext.compdef.ide.contentassist.antlr.internal.InternalCompDefParser;
import org.eclipse.papyrus.robotics.xtext.compdef.services.CompDefGrammarAccess;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;

public class CompDefParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(CompDefGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, CompDefGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getParameterAccess().getAlternatives_2_1(), "rule__Parameter__Alternatives_2_1");
			builder.put(grammarAccess.getValueAccess().getAlternatives(), "rule__Value__Alternatives");
			builder.put(grammarAccess.getUnlimitedLiteralAccess().getAlternatives(), "rule__UnlimitedLiteral__Alternatives");
			builder.put(grammarAccess.getVisibilityKindAccess().getAlternatives(), "rule__VisibilityKind__Alternatives");
			builder.put(grammarAccess.getDirectionAccess().getAlternatives(), "rule__Direction__Alternatives");
			builder.put(grammarAccess.getComponentAccess().getGroup(), "rule__Component__Group__0");
			builder.put(grammarAccess.getParameterAccess().getGroup(), "rule__Parameter__Group__0");
			builder.put(grammarAccess.getParameterAccess().getGroup_2(), "rule__Parameter__Group_2__0");
			builder.put(grammarAccess.getParameterAccess().getGroup_4(), "rule__Parameter__Group_4__0");
			builder.put(grammarAccess.getPortAccess().getGroup(), "rule__Port__Group__0");
			builder.put(grammarAccess.getPortAccess().getGroup_2(), "rule__Port__Group_2__0");
			builder.put(grammarAccess.getPortAccess().getGroup_3(), "rule__Port__Group_3__0");
			builder.put(grammarAccess.getActivityAccess().getGroup(), "rule__Activity__Group__0");
			builder.put(grammarAccess.getConnectorAccess().getGroup(), "rule__Connector__Group__0");
			builder.put(grammarAccess.getQualifiedNameAccess().getGroup(), "rule__QualifiedName__Group__0");
			builder.put(grammarAccess.getTypeRuleAccess().getGroup(), "rule__TypeRule__Group__0");
			builder.put(grammarAccess.getMultiplicityRuleAccess().getGroup(), "rule__MultiplicityRule__Group__0");
			builder.put(grammarAccess.getMultiplicityRuleAccess().getGroup_2(), "rule__MultiplicityRule__Group_2__0");
			builder.put(grammarAccess.getComponentAccess().getNameAssignment_1(), "rule__Component__NameAssignment_1");
			builder.put(grammarAccess.getComponentAccess().getPortsAssignment_3(), "rule__Component__PortsAssignment_3");
			builder.put(grammarAccess.getComponentAccess().getActivityAssignment_4(), "rule__Component__ActivityAssignment_4");
			builder.put(grammarAccess.getComponentAccess().getParametersAssignment_5(), "rule__Component__ParametersAssignment_5");
			builder.put(grammarAccess.getParameterAccess().getNameAssignment_1(), "rule__Parameter__NameAssignment_1");
			builder.put(grammarAccess.getParameterAccess().getTypeAssignment_2_1_0(), "rule__Parameter__TypeAssignment_2_1_0");
			builder.put(grammarAccess.getParameterAccess().getTypeUndefinedAssignment_2_1_1(), "rule__Parameter__TypeUndefinedAssignment_2_1_1");
			builder.put(grammarAccess.getParameterAccess().getMultiplicityAssignment_3(), "rule__Parameter__MultiplicityAssignment_3");
			builder.put(grammarAccess.getParameterAccess().getValueAssignment_4_1(), "rule__Parameter__ValueAssignment_4_1");
			builder.put(grammarAccess.getParameterAccess().getCommentAssignment_5(), "rule__Parameter__CommentAssignment_5");
			builder.put(grammarAccess.getValueAccess().getStrAssignment_0(), "rule__Value__StrAssignment_0");
			builder.put(grammarAccess.getValueAccess().getIvalAssignment_1(), "rule__Value__IvalAssignment_1");
			builder.put(grammarAccess.getValueAccess().getDvalAssignment_2(), "rule__Value__DvalAssignment_2");
			builder.put(grammarAccess.getPortAccess().getNameAssignment_1(), "rule__Port__NameAssignment_1");
			builder.put(grammarAccess.getPortAccess().getProvAssignment_2_1(), "rule__Port__ProvAssignment_2_1");
			builder.put(grammarAccess.getPortAccess().getReqAssignment_3_1(), "rule__Port__ReqAssignment_3_1");
			builder.put(grammarAccess.getActivityAccess().getNameAssignment_1(), "rule__Activity__NameAssignment_1");
			builder.put(grammarAccess.getConnectorAccess().getNameAssignment_1(), "rule__Connector__NameAssignment_1");
			builder.put(grammarAccess.getConnectorAccess().getEndAssignment_3(), "rule__Connector__EndAssignment_3");
			builder.put(grammarAccess.getConnectorEndAccess().getPortAssignment(), "rule__ConnectorEnd__PortAssignment");
			builder.put(grammarAccess.getQualifiedNameAccess().getPathAssignment_0(), "rule__QualifiedName__PathAssignment_0");
			builder.put(grammarAccess.getQualifiedNameAccess().getRemainingAssignment_2(), "rule__QualifiedName__RemainingAssignment_2");
			builder.put(grammarAccess.getTypeRuleAccess().getPathAssignment_0(), "rule__TypeRule__PathAssignment_0");
			builder.put(grammarAccess.getTypeRuleAccess().getTypeAssignment_1(), "rule__TypeRule__TypeAssignment_1");
			builder.put(grammarAccess.getMultiplicityRuleAccess().getBoundsAssignment_1(), "rule__MultiplicityRule__BoundsAssignment_1");
			builder.put(grammarAccess.getMultiplicityRuleAccess().getBoundsAssignment_2_1(), "rule__MultiplicityRule__BoundsAssignment_2_1");
			builder.put(grammarAccess.getBoundSpecificationAccess().getValueAssignment(), "rule__BoundSpecification__ValueAssignment");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private CompDefGrammarAccess grammarAccess;

	@Override
	protected InternalCompDefParser createParser() {
		InternalCompDefParser result = new InternalCompDefParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public CompDefGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(CompDefGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
